<?php
if (!function_exists('getTableData')) {

	function getTableData($tableName, $where = array(), $order_by = '', $order_type = '') {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$rows = $CI -> main_model -> getData($tableName, '*', $where, $order_by, $order_type);
		return $rows;
	}

	function getTableDataRow($tableName, $where = array(), $order_by = '', $order_type = '') {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$rows = $CI -> main_model -> getData($tableName, '*', $where, $order_by, $order_type);
		if ($rows) {
			$rows = $rows[0];
		}
		return $rows;
	}

	function getTableDataFields($tableName, $fields = '', $where = array(), $order_by = '', $order_type = '') {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$rows = $CI -> main_model -> getData($tableName, $fields, $where, $order_by = '', $order_type = '');
		return $rows;
	}

	function getTableDataRowFields($tableName, $fields = '', $where = array(), $order_by = '', $order_type = '') {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$rows = $CI -> main_model -> getData($tableName, $fields, $where, $order_by = '', $order_type = '');
		if ($rows) {
			$rows = $rows[0];
		}
		return $rows;
	}

	function Get7goZaTDataReport($tbl = 'bst_akwakh_booked', $prfild = 'price') {

		$CI = &get_instance();
		$CI -> db -> select("SUM(GT.$prfild) AS SumR, COUNT(GT.id) AS CountR ");
		$CI -> db -> from("$tbl  GT ");

		if (isset($_GET['dateFrm']) && trim($_GET['dateFrm']) != "") {
			$CI -> db -> where('GT.created >=', trim($_GET['dateFrm']));
		}

		if (isset($_GET['dateTo']) && trim($_GET['dateTo']) != "") {
			$CI -> db -> where('GT.created <=', trim($_GET['dateTo']));
		}

		/*
		 if ($sofra_id > 0) {
		 $CI -> db -> where('SU.sofrat_id', $sofra_id);
		 }

		 */

		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> row_array();

		} else {
			return array("SumR" => 0, "CountR" => 0);
		}

	}

	function Get7goZaTFatartDataReport($kow_id = 0, $ftra_id = 0) {

		$CI = &get_instance();
		$CI -> db -> select("SUM(GT.total_price) AS SumR, COUNT(GT.id) AS CountR ");
		$CI -> db -> from("bst_akwakh_booked  GT ");

		$CI -> db -> where('GT.kwokh_id ', $kow_id);

		$CI -> db -> where('GT.dt_id', $ftra_id);
		$CI -> db -> where('GT.paid', 1);

		if (isset($_GET['dateFrm']) && trim($_GET['dateFrm']) != "") {
			$CI -> db -> where('GT.day_booking >=', trim($_GET['dateFrm']));
		}

		if (isset($_GET['dateTo']) && trim($_GET['dateTo']) != "") {
			$CI -> db -> where('GT.day_booking <=', trim($_GET['dateTo']));
		}

		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> row_array();

		} else {
			return array("SumR" => 0, "CountR" => 0);
		}

	}

	function CountCountSubscriberIncategory($catid = 0) {
		$CI = &get_instance();
		$CI -> db -> select('CSB.*');
		$CI -> db -> from('course_subscribers CSB');
		$CI -> db -> join('courses CRS', 'CRS.id=CSB.course_id');
		if ($catid > 0) {
			$CI -> db -> where('CRS.category_id', $catid);
		}

		$query = $CI -> db -> get();
		return $query -> num_rows();

	}

	function GetCurrency() {
		return " دولار ";
	}

	function ArrayToString($arr) {
		if (empty($arr)) {
			return "";
		}

		$comma_separated = implode(",", $arr);
		return $comma_separated;
		// lastname,email,phone

	}

	function getEvaluationOFCoupon($couponID) {
		$nesba = 0;
		$countAll = GetGlobalCount("coupon_like_dislike", array("coupon_id" => $couponID));
		$countUp = GetGlobalCount("coupon_like_dislike", array("coupon_id" => $couponID, "up_down" => 1));
		if ($countAll > 0 && $countUp > 0) {

			return round(($countUp / $countAll) * 100, 2);
		}
		return $nesba;

	}

	function CheckInString($wrd, $str) {
		if (empty($str)) {
			return " ";
		}

		$arr = explode(",", $str);
		//$arr = array_flip (  $arr );

		if (in_array($wrd, $arr)) {
			return " checked='checked' ";
		}

		return " ";
		// lastname,email,phone

	}

	function upload_file($filename, $path) {
		$config['upload_path'] = FCPATH . $path;
		$config['allowed_types'] = '*';
		//$config['allowed_types'] = 'gif|jpg|png|jpeg|GIF|JPEG|PNG|pdf|doc|docx|xls|xlsx|xlsm';

		$config['max_size'] = '1000000';

		$config['overwrite'] = FALSE;

		if (!is_dir($config['upload_path']))
			die("THE UPLOAD DIRECTORY DOES NOT EXIST");
		$CI = &get_instance();
		$CI -> load -> library('upload', $config);

		if (!$CI -> upload -> do_upload("{$filename}")) {
			//var_dump($CI->upload->display_errors());

			return false;
		} else {
			$dataSucces = $CI -> upload -> data();
			return $dataSucces["file_name"];

			//-return array('upload_data' => $this->upload->data("file_name"));
		}
	}

	function GetGlobalData($tab_name, $whre = null, $orderBY = null, $orderType = null, $limt = null) {

		$CI = &get_instance();
		$CI -> db -> select('*');
		$CI -> db -> from($tab_name);
		if ($whre != null) {
			$CI -> db -> where($whre);
		}

		if ($limt != null) {
			$CI -> db -> limit($limt, 0);
		}

		if ($orderBY != null) {
			$CI -> db -> order_by($orderBY, $orderType);
		}

		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetKwokhDayTimeDATA($ko_ID, $Ftr_ID) {

		return getTableDataRow("bst_akwakh_day_times", $where = array('kwokh_id' => $ko_ID, 'day_time_id' => $Ftr_ID, 'enabled' => 1));
	}

	function CheckBookedKowkhDayTimeINdate($kokh_DT_ID, $DateDay) {

		$CI = &get_instance();

		$selCTStment = " SELECT * From bst_akwakh_booked 
		WHERE  (bst_akwakh_booked.day_booking='$DateDay' AND  bst_akwakh_booked.adt_id=$kokh_DT_ID  )";
		$query = $CI -> db -> query($selCTStment);
		$resArr = $query -> result_array();
		if ($resArr) :
			return true;
		endif;

		return false;

	}

	function arabic_date_format($timestamp) {
		$timestamp = strtotime("$timestamp");
		$periods = array("second" => "ثانية", "seconds" => "ثواني", "minute" => "دقيقة", "minutes" => "دقائق", "hour" => "ساعة", "hours" => "ساعات", "day" => "يوم", "days" => "أيام", "month" => "شهر", "months" => "شهور", );

		$difference = (int) abs(time() - $timestamp);

		$plural = array(3, 4, 5, 6, 7, 8, 9, 10);

		$readable_date = "منذ ";

		if ($difference < 60)// less than a minute
		{
			$readable_date .= $difference . " ";
			if (in_array($difference, $plural)) {
				$readable_date .= $periods["seconds"];
			} else {
				$readable_date .= $periods["second"];
			}
		} elseif ($difference < (60 * 60))// less than an hour
		{
			$diff = (int)($difference / 60);
			$readable_date .= $diff . " ";
			if (in_array($diff, $plural)) {
				$readable_date .= $periods["minutes"];
			} else {
				$readable_date .= $periods["minute"];
			}
		} elseif ($difference < (24 * 60 * 60))// less than a day
		{
			$diff = (int)($difference / (60 * 60));
			$readable_date .= $diff . " ";
			if (in_array($diff, $plural)) {
				$readable_date .= $periods["hours"];
			} else {
				$readable_date .= $periods["hour"];
			}
		} elseif ($difference < (30 * 24 * 60 * 60))// less than a month
		{
			$diff = (int)($difference / (24 * 60 * 60));
			$readable_date .= $diff . " ";
			if (in_array($diff, $plural)) {
				$readable_date .= $periods["days"];
			} else {
				$readable_date .= $periods["day"];
			}
		} elseif ($difference < (365 * 24 * 60 * 60))// less than a year
		{
			$diff = (int)($difference / (30 * 24 * 60 * 60));
			$readable_date .= $diff . " ";

			if (in_array($diff, $plural)) {
				$readable_date .= $periods["months"];
			} else {
				$readable_date .= $periods["month"];
			}
		} else {
			$readable_date = date("d-m-Y", $timestamp);
		}

		return $readable_date;
	}

	function getSettingdata() {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$rows = $CI -> main_model -> getData("intro_settings");
		if ($rows) {
			$rows = $rows[0];
		}
		return $rows;
	}

	/*******************************/

	function UpdateUserlastVisit() {
		$user_id = get_Front_logedin_id();
		if ($user_id > 0) {
			$now_time = date("Y-m-d H:i:s");
			$CI = &get_instance();
			$CI -> load -> model('main_model');
			$CI -> main_model -> update('users', array("last_visit" => $now_time), array("user_id" => $user_id));

		}

	}

	function CountPostsInMainCat($main_catid) {
		$CI = &get_instance();
		$CI -> db -> select('MP.id');
		$CI -> db -> from('main_posts MP');
		$CI -> db -> join('sub_categories SC', 'SC.id=MP.sub_cat_id');
		$CI -> db -> join('main_categories MC', 'MC.id=SC.main_cat_id');

		//$this -> db -> join('faq_answers FA', 'FA.faq_question_id=FQ.id', 'left');
		$CI -> db -> where('SC.main_cat_id', $main_catid);

		$query = $CI -> db -> get();
		return $query -> num_rows();

	}

	function GetGlobalCount($tab_name, $whre = null) {

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		$total_rows = $CI -> main_model -> count($tab_name, $whre);
		return $total_rows;

	}

	function short_func_bestsol($text, $length, $after = '..') {

		$text = trim(strip_tags($text));
		if (strlen($text) <= $length)
			return $text;
		$text = substr($text, 0, strpos($text, ' ', $length - 1));
		return $text . $after;
	}

	function GetPortfolioSkills($project_id) {
		$CI = &get_instance();
		$CI -> db -> select('S.*');
		$CI -> db -> from('portfolios_skills PS');
		$CI -> db -> join('skills S', 'S.id=PS.skills_id');
		//$this -> db -> join('faq_answers FA', 'FA.faq_question_id=FQ.id', 'left');
		$CI -> db -> where('PS.portfolios_id', $project_id);

		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			$arrData = $query -> result();

			return $arrData;

		} else {
			return false;
		}

	}

	function GetQuestionZatSela($questionID, $cat_IDX, $tabl = "faq_questions") {
		$CI = &get_instance();
		$CI -> db -> select('*');

		$CI -> db -> from($tabl);
		if ($tabl == "faq_questions") {
			$CI -> db -> where('faq_cat_id', $cat_IDX);
		} else {
			$CI -> db -> where('forum_cat_id', $cat_IDX);
		}

		$CI -> db -> where('id !=', $questionID);
		$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function getFaqQuestionTags($tagstxt, $tbl = "faq_tags") {

		$arry = explode(',', $tagstxt);
		$temptxt = "";
		$CI = &get_instance();
		$CI -> db -> select('tag_name');

		$CI -> db -> from($tbl);

		$CI -> db -> where_in('id', $arry);

		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {

			return $query -> result();

		}

		return false;
	}

	function getTotalLikesForuser($user_ID) {

		$CI = &get_instance();
		$CI -> db -> select('SUM(MainP.like_count) AS SumR');
		$CI -> db -> from('main_posts MainP');

		$CI -> db -> where('MainP.user_id', $user_ID);
		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> row() -> SumR;

		} else {
			return false;
		}

	}

	function getTotalUnLikesForuser($user_ID) {

		$CI = &get_instance();
		$CI -> db -> select('SUM(MainP.unlike_count) AS SumR');
		$CI -> db -> from('main_posts MainP');

		$CI -> db -> where('MainP.user_id', $user_ID);
		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> row() -> SumR;

		} else {
			return false;
		}

	}

	function getRecommendationOfuser($user_ID) {
		$CI = &get_instance();

		$CI -> db -> select('UR.*,usrs.*');
		$CI -> db -> from('users_recommendations UR');
		$CI -> db -> join('users usrs', 'usrs.user_id=UR.recommender_id');

		$CI -> db -> where('UR.recommended_id', $user_ID);
		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function getNavigationClass($counter) {

		$perPge = getEntriesPerPage();

		$page_number = ceil($counter / $perPge);

		if ($counter <= $perPge) {

			return "AllLstBstRows nv_rw_bst_$page_number";
		}

		return "AllLstBstRows nv_rw_bst_$page_number hideThspGenaV ";

	}

	function getEntriesPerPage() {
		$settingdata = getSettingdata();

		return $settingdata -> entry_per_page;
	}

	function getPostiveratingOfuser($user_ID) {

		return 5;
	}

	function getAverageResonseTimeOfuser($user_ID) {

		return "5 دقائق";
	}

	function getPostSoldCount($post_ID) {

		return 0;
	}

	function getPostWantOffersCount($post_ID) {
		return 0;

	}

	function GetPostModatEstigaba($post_ID) {
		return 4;
	}

	function GetPostTalbatMotA5ra($post_ID) {
		return 1;
	}

	function GetPostMotawsetTaslem($post_ID) {
		return 7;
	}

	function GetPostTalbatGaria($post_ID) {
		return 10;
	}

	function GlobalChecktable($tble_name, $where) {
		$CI = &get_instance();
		$CI -> db -> select('*');
		$CI -> db -> from($tble_name);
		$CI -> db -> where($where);
		//$CI -> db -> where('UF.follower_id', $follower_id);
		//$CI -> db -> where('UF.followed_id', $followed_id);
		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return true;

		} else {
			return false;
		}
	}

	function getTotalFollowers($user_id) {

		$CI = &get_instance();
		$CI -> db -> select('SUM(UF.id) AS SumR');
		$CI -> db -> from('users_followers UF');

		$CI -> db -> where('UF.follower_id', $user_id);
		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> row() -> SumR;

		} else {
			return false;
		}

	}

	function getLastAnswerDate($question_id, $tbl = "faq_answers") {
		$CI = &get_instance();
		$CI -> db -> select('created_date');
		$CI -> db -> from($tbl);

		$WhreSlctor = ($tbl == "faq_answers") ? "faq_question_id" : "forum_question_id";
		$CI -> db -> where($WhreSlctor, $question_id);
		//$CI -> db -> limit(4, 0);
		$CI -> db -> order_by("created_date", "DESC");
		$query = $CI -> db -> get();

		if ($query -> num_rows() != 0) {
			return $query -> row() -> created_date;

		} else {
			return false;
		}

	}

	function GetCountFaqAnswers($tabl = "faq_answers") {

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		$total_rows = $CI -> main_model -> count("$tabl");
		return $total_rows;

	}

	function GetCountFaqQuestions($tbl = "faq_questions") {

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		$total_rows = $CI -> main_model -> count("$tbl");
		return $total_rows;

	}

	function GetFaqQuestionAnswersList($questionID, $tbl = "faq_answers") {

		$CI = &get_instance();
		$CI -> db -> select('FA.*,usrs.full_name,usrs.user_image');
		$CI -> db -> from("$tbl FA");
		$CI -> db -> join('users usrs', 'usrs.user_id=FA.user_id');

		$WhreSlctor = ($tbl == "faq_answers") ? "faq_question_id" : "forum_question_id";

		$CI -> db -> where("FA.$WhreSlctor", $questionID);

		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetFaqCategoriesList($tbl = "faq_categories") {

		$CI = &get_instance();
		$CI -> db -> select('*');
		$CI -> db -> from($tbl);

		//$CI -> db -> where('id', $page_id);
		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetPageData($page_id) {
		$CI = &get_instance();
		$CI -> db -> select('*');
		$CI -> db -> from('static_pages');

		$CI -> db -> where('id', $page_id);
		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> row();

		} else {
			return false;
		}

	}

	function getTotalFolloweds($user_id) {

		$CI = &get_instance();
		$CI -> db -> select('SUM(UF.id) AS SumR');
		$CI -> db -> from('users_followers UF');

		$CI -> db -> where('UF.followed_id', $user_id);
		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> row() -> SumR;

		} else {
			return false;
		}

	}

	function GetAllUserStatuses($user_id) {
		$CI = &get_instance();

		$CI -> db -> select('US.*');
		$CI -> db -> from('users_statuses US');

		$CI -> db -> where('US.user_id', $user_id);
		//$CI -> db -> limit(4, 0);
		$CI -> db -> order_by('US.created_date', 'DESC');
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function getAllStarsOfPost($post_id) {
		$CI = &get_instance();

		$CI -> db -> select('COUNT(PLikes.id) AS CountR, SUM(PLikes.stars_count) AS SumR');
		$CI -> db -> from('posts_likes PLikes');

		$CI -> db -> where('PLikes.post_id', $post_id);
		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> row();

		} else {
			return false;
		}

	}

	function GetPostOfferss($post_id) {

		$CI = &get_instance();

		$CI -> db -> select('PotOffrs.*,usrs.*');
		$CI -> db -> from('posts_offers PotOffrs');
		//$CI -> db -> join('sub_categories SubCat', 'SubCat.id=MPosts.sub_cat_id');
		$CI -> db -> join('users usrs', 'usrs.user_id=PotOffrs.user_id');

		//-$CI -> db -> where('SubCat.main_cat_id', $post_maincat);
		$CI -> db -> where('PotOffrs.post_id', $post_id);
		$CI -> db -> order_by('PotOffrs.id', 'ASC');
		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetPostTags($post_id) {

		$CI = &get_instance();
		$CI -> load -> model('posts_model');
		$row = $CI -> posts_model -> GetPostsData($post_id);
		$post_maincat = $row -> maincat_id;

		$CI -> db -> select('SubCat.*');
		$CI -> db -> from('sub_categories SubCat');
		//$CI -> db -> join('sub_categories SubCat', 'SubCat.id=MPosts.sub_cat_id');

		//-$CI -> db -> where('SubCat.main_cat_id', $post_maincat);
		$CI -> db -> where('SubCat.main_cat_id', $post_maincat);
		$CI -> db -> order_by('SubCat.id', 'RANDOM');
		//$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetUserOnliNeOrNot($last_visit) {

		$now_time = date("Y-m-d H:i:s");

		$time_5 = strtotime("$last_visit + 5 minute");
		$time_5_format = date('Y-m-d H:i:s', $time_5);

		return ($time_5_format < $now_time) ? " غير موجود" : "موجود ";

	}

	function GetPostEvaluation($post_ID) {

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$total_rows = $CI -> main_model -> count("posts_likes", array("post_id" => $post_ID));
		$total_rows = ($total_rows > 0) ? $total_rows : 1;

		$total_like = $CI -> main_model -> count("posts_likes", array("post_id" => $post_ID, 'status' => 1));
		$total_like = ($total_like > 0) ? $total_like : 1;

		return ($total_like / $total_rows) * 100;

	}

	function GetUserLevelname($level_ID) {
		$CI = &get_instance();
		$CI -> db -> select('user_levels.level_name');
		$CI -> db -> from('user_levels');

		$CI -> db -> where('user_levels.id', $level_ID);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			$rows = $query -> result();
			return $rows[0] -> level_name;
		} else {
			return false;
		}

	}

	function getKhadamatMoktar7aOfPost($post_id) {

		$CI = &get_instance();
		$CI -> load -> model('posts_model');
		$row = $CI -> posts_model -> GetPostsData($post_id);
		$post_maincat = $row -> maincat_id;

		$CI -> db -> select('MPosts.*,usrs.*,SubCat.name AS subcat_name');
		$CI -> db -> from('main_posts MPosts');
		$CI -> db -> join('users usrs', 'usrs.user_id=MPosts.user_id');
		$CI -> db -> join('sub_categories SubCat', 'SubCat.id=MPosts.sub_cat_id');

		//-$CI -> db -> where('SubCat.main_cat_id', $post_maincat);
		$CI -> db -> where('MPosts.active', 1);
		$CI -> db -> order_by('MPosts.id', 'RANDOM');
		$CI -> db -> limit(4, 0);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function getOtherKhadamatForUser($user_id) {

		$CI = &get_instance();
		$CI -> db -> select('MPosts.*,usrs.*,SubCat.name AS subcat_name');
		$CI -> db -> from('main_posts MPosts');
		$CI -> db -> join('users usrs', 'usrs.user_id=MPosts.user_id');
		$CI -> db -> join('sub_categories SubCat', 'SubCat.id=MPosts.sub_cat_id');

		$CI -> db -> where('MPosts.user_id', $user_id);
		$CI -> db -> where('MPosts.active', 1);
		$CI -> db -> order_by('MPosts.id', 'RANDOM');
		$CI -> db -> limit(4, 1);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();

		} else {
			return false;
		}

	}

	function GetPostComments($post_ID) {

		$CI = &get_instance();
		$CI -> db -> select('PComments.*,usrs.full_name,usrs.user_image');
		$CI -> db -> from('posts_comments PComments');
		$CI -> db -> join('users usrs', 'usrs.user_id=PComments.user_id');
		$CI -> db -> where('PComments.post_id', $post_ID);
		$CI -> db -> order_by('PComments.id', "ASC");

		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();
		} else {
			return false;
		}

	}

	function GetPostLikes($post_ID) {

		$CI = &get_instance();
		$CI -> db -> select('PLikes.*,usrs.full_name,usrs.user_image');
		$CI -> db -> from('posts_likes PLikes');
		$CI -> db -> join('users usrs', 'usrs.user_id=PLikes.user_id');
		$CI -> db -> where('PLikes.post_id', $post_ID);
		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			return $query -> result();
		} else {
			return false;
		}

	}

	function GetPostTaraWrat($post_ID) {

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$rows = $CI -> main_model -> getData("main_posts_tatwrat", array(), array("post_id" => $post_ID));
		return $rows;

	}

	function GetPostImages($post_ID) {

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$rows = $CI -> main_model -> getData("main_posts_images", array(), array("post_id" => $post_ID));
		return $rows;

	}

	function getSkillsText($skillstxt) {

		$arry = explode(',', $skillstxt);
		$temptxt = "";
		$CI = &get_instance();
		$CI -> db -> select('skill_name');

		$CI -> db -> from('skills');

		$CI -> db -> where_in('id', $arry);

		$query = $CI -> db -> get();
		if ($query -> num_rows() != 0) {
			$result = $query -> result();
			foreach ($result AS $resultone) {
				$temptxt .= " , " . $resultone -> skill_name;
			}

		}

		return $temptxt;
	}

	function GetSubcategorydataBYid($subCatid) {

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$rows = $CI -> main_model -> getData("sub_categories", array(), array("id" => $subCatid));
		if ($rows) {
			$rows = $rows[0];
		}
		return $rows;

	}

	function GetMaincategorydataBYid($mainCatid) {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$rows = $CI -> main_model -> getData("main_categories", array(), array("id" => $mainCatid));
		if ($rows) {
			$rows = $rows[0];
		}
		return $rows;

	}

	function deletNumbersFromPrivateGroup($group_id) {

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		$CI -> main_model -> delete('private_groups_numbers', array("private_group_id" => $group_id));

	}

	function insertNumberToPrivateGroup($private_group, $phoneNumber) {
		$phoneNumber = trim($phoneNumber);

		if ($phoneNumber == "")
			return false;

		$check_number_exist = getTableDataRow("private_groups_numbers", array("private_group_id" => $private_group, "number" => $phoneNumber));

		if (!$check_number_exist) {

			$CI = &get_instance();
			$CI -> load -> model('main_model');
			$numberArr = array();
			$numberArr['number'] = $phoneNumber;
			$numberArr['private_group_id'] = $private_group;
			$CI -> main_model -> insert('private_groups_numbers', $numberArr);

		}

	}

	function getUserData($userID) {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$row = $CI -> main_model -> getData("users", '*', array("user_id" => $userID));
		if ($row) {
			$row = $row[0];
			//$row -> photoPath = base_url() . 'third_party/uploads/profiles/' . $row -> photo;

		}

		return $row;
	}

	function get_user_credit($user_id = 0) {

		$userdata = getUserData($user_id);

		if ($userdata) {
			return $userdata -> points;
		}
		return 0;
	}

	function get_current_user_credit() {
		if (get_Front_logedin_id() == 0)
			return 0;

		$userdata = getUserData(get_Front_logedin_id());

		if ($userdata) {
			return $userdata -> points;
		}
		return 0;
	}

	function count_numbers_private_group($groupID = 0) {

		$CI = &get_instance();
		$CI -> load -> model('main_model');

		$count = $CI -> main_model -> count('private_groups_numbers', array("private_group_id" => $groupID));

		return $count;

	}

	function count_numbers_campagign_zone($zoneID = 0) {

		$CI = &get_instance();
		$CI -> load -> model('main_model');

		$count = $CI -> main_model -> count("zones_numbers", array("zone_id" => $zoneID));

		return $count;

	}

	function increase_sms_credit($user_id, $number_of_sms = 0) {

		$userdata = getUserData($user_id);
		if ($userdata) {
			$userCredit = $userdata -> points;

			$new_credit = $userCredit + $number_of_sms;
			$CI = &get_instance();
			$CI -> load -> model('main_model');
			$CI -> main_model -> update('users', array("points" => $new_credit), array("user_id" => $user_id));
			return true;

		}
		return false;
	}

	function make_sent_scheduled($scheduled_id) {

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		$CI -> main_model -> update('scheduled_sms', array("sent" => 1), array("id" => $scheduled_id));

	}

	function decrease_sms_credit($number_of_sms = 0) {
		if (get_Front_logedin_id() == 0)
			return false;

		$userdata = getUserData(get_Front_logedin_id());

		if ($userdata) {
			$userCredit = $userdata -> points;

			$new_credit = $userCredit - $number_of_sms;
			$CI = &get_instance();
			$CI -> load -> model('main_model');
			$CI -> main_model -> update('users', array("points" => $new_credit), array("user_id" => get_Front_logedin_id()));
			return true;

		}
		return false;
	}

	function currency_convert($from, $to, $amount) {
		$string = "1" . $from . "=?" . $to;
		$google_url = "http://www.google.com/ig/calculator?hl=en&q=" . $string;
		$result = file_get_contents($google_url);
		$result = explode('"', $result);
		$converted_amount = explode(' ', $result[3]);
		$conversion = $converted_amount[0];
		$conversion = $conversion * $amount;
		$conversion = round($conversion, 2);
		$rhs_text = ucwords(str_replace($converted_amount[0], "", $result[3]));
		$rhs = $conversion . $rhs_text;
		$price = preg_replace('_^\D+|\D+$_', "", $rhs);
		return number_format($price, 2, '.', ',');
	}

	//echo currency_convert('GBP', 'USD',250.75); # convert 250.75 USD into equivalent GBP

	function insertPhoneNumberToZone($zoneId, $phoneNumber) {

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		$userSessionArr = array();
		$userSessionArr['mobile_number'] = trim($phoneNumber);
		$userSessionArr['zone_id'] = $zoneId;
		$CI -> main_model -> insert('zones_numbers', $userSessionArr);

	}

	function CheckPhoneNumberInZone($zoneId, $phoneNumber) {

		$CI = &get_instance();
		$CI -> db -> select("*");
		$CI -> db -> where(array('mobile_number' => $phoneNumber, "zone_id" => $zoneId));
		$query = $CI -> db -> get('zones_numbers');
		$resArr = $query -> result_array();
		if ($resArr) {
			return $resArr[0];
		}
		return false;

	}

	function getCurrentLangDB() {

		return "_en";
	}

	function getWarmupVariable() {
		return 10;
	}

	function getHoursDiff($date) {

		$dateNOw = date('Y-m-d H:i:s');

		if ($date < $dateNOw)
			return -1;

		$date1 = date_create("$date");
		//$sessinData['date1'] = $date1;
		$date2 = date_create("$dateNOw");
		//$sessinData['date2'] = $date2;
		$diff12 = date_diff($date2, $date1);
		$Diff_Hours = $diff12 -> h;
		$Diff_Days = $diff12 -> d;
		$diFFInHours = ($Diff_Days * 24) + $Diff_Hours;
		return $diFFInHours;

	}

	function InsertProgramDefaults($client_id) {
		$CI = &get_instance();
		$CI -> load -> model('main_model');

		$userSessionArr = array();
		$userSessionArr['client_id'] = $client_id;
		$userSessionArr['program_id'] = 0;
		$userSessionArr['program_order'] = 0;

		$CI -> main_model -> insert('clients_programs', $userSessionArr);

	}

	function InsertUserSessionSInperiod($startDate, $sessionTime, $subscription_id) {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		$subscriptionData = getTableData("subscriptions", array("subscription_id" => $subscription_id));
		if ($subscriptionData) :
			//$subscriptionStartDate = $startDate;
			$subscriptionEndDate = $subscriptionData[0] -> end_date;
			$client_id = $subscriptionData[0] -> user_id;
			$packge_id = $subscriptionData[0] -> package_id;

			$packagesData = getTableData("packages", array("package_id" => $packge_id));
			$numOfDaysPerWeek = $packagesData[0] -> noOfSessionPerWeek;
			$sessionDuration = $packagesData[0] -> sessionDuration;

			$Dweeks = 0;
			$start_DateTemporary = $startDate;

			while ($start_DateTemporary <= $subscriptionEndDate) {

				$old_date_weeks = date($startDate);
				$date_new_weeks = date_create($old_date_weeks);
				date_add($date_new_weeks, date_interval_create_from_date_string("$Dweeks Weeks"));
				$date_weeks = date_format($date_new_weeks, 'Y-m-d');
				$start_DateTemporary = $date_weeks;

				$startSessionDateTime = date("Y-m-d H:i:s", strtotime("{$date_weeks} {$sessionTime}"));
				$endSessionDateTime = date("Y-m-d H:i:s", strtotime("+{$sessionDuration} minutes", strtotime($startSessionDateTime)));

				$userSessionArr = array();
				$userSessionArr['start_time'] = $startSessionDateTime;
				$userSessionArr['end_time'] = $endSessionDateTime;
				$userSessionArr['user_id'] = $client_id;
				$userSessionArr['coach_id'] = 0;
				$userSessionArr['program'] = " ";

				if ($date_weeks <= $subscriptionEndDate) {
					$CI -> main_model -> insert('usersession', $userSessionArr);
					InsertProgramDefaults($client_id);
				}

				$Dweeks++;

			}

		endif;

	}

	function GetUserSessionByUserIdAndStartTime($userId, $startDateTime) {

		$CI = &get_instance();
		$CI -> db -> select("usersession.*");

		//$date_Start_Time = date_create($startDateTime);
		//$date_Start_Time_Hour_Minutes = strtolower(date_format($date_Start_Time, 'H:i:s'));

		$date = GetDateOnlyFromDateTime($startDateTime);

		//-echo "date/".$date ."start /".$date_Start_Time_Hour_Minutes . "end /".$date_End_Time_Hour_Minutes;

		$CI -> db -> from('usersession');
		$CI -> db -> join('sessions', 'usersession.sesssion_id = sessions.session_id');

		$CI -> db -> where(array('date(sessions.start_time)' => $date, 'usersession.user_id' => $userId));
		$CI -> db -> order_by('sessions.start_time', 'ASC');
		$query = $CI -> db -> get();
		$resArr = $query -> result_array();

		return $resArr;
	}

	function GetCheckedTrainersInDate($date) {

		$CI = &get_instance();
		$CI -> db -> select("DISTINCT(coach_id)");
		$CI -> db -> where(array('date(datetimecheckin)' => $date));
		$query = $CI -> db -> get('coach_checkin');
		$resArr = $query -> result_array();
		return $resArr;

	}

	function GetCheckedTrainersInShiftByShiftId($shiftId, $date) {

		$CI = &get_instance();
		$CI -> db -> select("*");
		$CI -> db -> where(array('date(datetimecheckin)' => $date, 'shift_id' => $shiftId));
		$query = $CI -> db -> get('coach_checkin');
		$resArr = $query -> result_array();
		return $resArr;

	}

	function GetUsersSessionsByShiftId($shiftId) {

	}

	function ChangeRemainingSessionCounterByUserID($userIDD, $counter) {

		$activePackage = getCurrentPackage($userIDD);

		if ($activePackage) :

			$subscriptionIDD = $activePackage -> subscription_id;
			$remainingSessions = $activePackage -> remainingsessions;

			$arrOpened = array();
			$arrOpened['remainingsessions'] = $remainingSessions + ($counter);

			$CI = &get_instance();
			$CI -> load -> model('main_model');
			$CI -> main_model -> update('subscriptions', $arrOpened, array('subscription_id' => $subscriptionIDD));

		endif;

	}

	function increaseRemainingSession($user_session_id) {

		$usersessiondata = getTableData("usersession", array('user_sessionid' => $user_session_id));
		if ($usersessiondata) {

			$usersessiondata = $usersessiondata[0];
			$userIDD = $usersessiondata -> user_id;

			$activePackage = getCurrentPackage($userIDD);

			if ($activePackage) :

				$subscriptionIDD = $activePackage -> subscription_id;
				$remainingSessions = $activePackage -> remainingsessions;

				$arrOpened = array();
				$arrOpened['remainingsessions'] = $remainingSessions + 1;

				$CI = &get_instance();
				$CI -> load -> model('main_model');
				$CI -> main_model -> update('subscriptions', $arrOpened, array('subscription_id' => $subscriptionIDD));

			endif;

		}

	}

	function DecreaseOpenSessionAvailablity($openSessionid, $flagID = 0) {
		$openssessiondata = getTableData("sessions", array("session_id" => $openSessionid));
		if ($openssessiondata) {

			$openssessiondata = $openssessiondata[0];
			$sessionAvaliable = $openssessiondata -> available;

			if ($flagID == 0) {
				$sessionAvaliable = $sessionAvaliable - 1;
			} else {
				$sessionAvaliable = $sessionAvaliable + 1;
			}
			//-------------update

			$arrOpened = array();
			$arrOpened['available'] = $sessionAvaliable;

			$CI = &get_instance();
			$CI -> load -> model('main_model');
			$CI -> main_model -> update('sessions', $arrOpened, array('session_id' => $openSessionid));

		}

	}

	function GetShiftDataByDateTime($dateTime) {

		$shiftType = CheckifCustomshiftsExist($dateTime);
		$CI = &get_instance();
		$CI -> db -> select("*");

		if ($shiftType == 2) :// custom
			$CI -> db -> where(array('date(start_time)' => GetDateOnlyFromDateTime($dateTime), 'start_time  <=' => $dateTime, 'shiftType' => 2));
		else :

			//$date="2015-01-23 20:00:00";
			$date_Start_Time = date_create($dateTime);
			$date_Start_Time_DAY = strtolower(date_format($date_Start_Time, 'l'));
			$date_Start_Time_Hour_Minutes = strtolower(date_format($date_Start_Time, 'H:i:s'));

			$CI -> db -> where(array('DAYNAME(start_time)' => $date_Start_Time_DAY, 'TIME(start_time)  <=' => $date_Start_Time_Hour_Minutes, 'shiftType' => 1));

		endif;

		$CI -> db -> order_by('start_time', 'ASC');
		$query = $CI -> db -> get('shifts');
		$resArr = $query -> result_array();

		$tempArr = array();
		if ($resArr) {
			$tempArr = $resArr[0];
		}

		return $tempArr;

	}

	function AssignCoachToUserSession($userSessionID, $coachID) {

		//-echo $userSessionID ." ".$coachID."<br/>";

		$arrOpened = array();
		$arrOpened['coach_id'] = $coachID;

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		$CI -> main_model -> update('usersession', $arrOpened, array('user_sessionid' => $userSessionID));

	}

	function cmp_by_optionNumber($a, $b) {
		return $a[0] - $b[0];
	}

	function cmp_by_optionNumberTrainers($a, $b) {
		return $a['TotalCountSess'] - $b['TotalCountSess'];
	}

	function array_sort_by_column(&$arr, $col, $dir = SORT_ASC) {
		$sort_col = array();
		foreach ($arr as $key => $row) {
			$sort_col[$key] = $row[$col];
		}

		array_multisort($sort_col, $dir, $arr);
	}

	function AssignAutomtically($arrOfStartEnds, $trainersInShift, $task = "autoassign") {
		/*echo "<pre>yyyyyyyyyyyy";
		 print_r($arrOfStartEnds);
		 echo "</pre>";*/
		$temOfTrainersx = array();
		//usort($arrOfStartEnds, "cmp_by_optionNumber");

		array_sort_by_column($arrOfStartEnds, 0);

		/*echo "<pre>xxxxxxxxx";
		 print_r($arrOfStartEnds);
		 echo "</pre>";*/

		$firstStart = $arrOfStartEnds[0][0];
		foreach ($trainersInShift AS $trainersXYz) {
			$temOfTrainersx[] = array("coachId" => $trainersXYz['coach_id'], "starttime" => $firstStart, "endtime" => $firstStart, "usersSessionId" => array(), "warpUpSEssions" => array(), "TotalCountSess" => 0);
		}
		$tempArr = array();
		$sessionArrOfWarmpuP = array();
		foreach ($arrOfStartEnds AS $arrOfStartEndsOne) :
			$realStart = $arrOfStartEndsOne[0];
			$realEnd = $arrOfStartEndsOne[1];

			//usort($temOfTrainersx, "cmp_by_optionNumberTrainers");

			array_sort_by_column($temOfTrainersx, 'TotalCountSess');

			foreach ($temOfTrainersx AS &$temOfTrainerONEE) {

				$tempTrainerEnd = $temOfTrainerONEE['endtime'];
				if ($realStart >= $tempTrainerEnd) {

					$temOfTrainerONEE['endtime'] = $realEnd;
					if ($arrOfStartEndsOne[2] > 0) {
						$temOfTrainerONEE['usersSessionId'][] = $arrOfStartEndsOne[2];
					} else {
						$temOfTrainerONEE['warpUpSEssions'][] = $arrOfStartEndsOne[0];

					}

					$temOfTrainerONEE['TotalCountSess'] += 1;
					break;

				}

			}

		endforeach;

		foreach ($temOfTrainersx AS $temOfTrainersxOne) :

			$coachId = $temOfTrainersxOne['coachId'];
			$trainerUserSessionArr = $temOfTrainersxOne['usersSessionId'];
			$trainerwarpUpSEssionsArr = $temOfTrainersxOne['warpUpSEssions'];

			//print_r($trainerUserSessionArr);

			if ($task == "autoassign") {

				if (count($trainerUserSessionArr) > 0) {

					foreach ($trainerUserSessionArr AS $UsersessionIDKey => $UsersessionIDVAl) {
						//-echo $UsersessionIDVAl ."//".$coachId;
						AssignCoachToUserSession($UsersessionIDVAl, $coachId);
					}

				}
			}

			//------------------------/

			if (count($trainerwarpUpSEssionsArr) > 0) {

				foreach ($trainerwarpUpSEssionsArr AS $warpUpKey => $warpUpVAl) {
					$sessionArrOfWarmpuP[] = array($warpUpVAl, $coachId);
				}

			}

		endforeach;
		if ($task == "getWarmup") {
			return $sessionArrOfWarmpuP;
		}
		/*$CI = &get_instance();

		 $CI -> load -> library('session');

		 $CI -> session -> set_userdata(array("WarmpuPArr"=> $sessionArrOfWarmpuP));*/
	}

	function genereateRequiredArray($arrOfStartEnds) {

		/*echo "<pre>";
		 print_r($arrOfStartEnds);
		 echo "</pre>";
		 */

		$tempArr = array();
		$tempArr[] = $arrOfStartEnds[0];
		unset($arrOfStartEnds[0]);

		foreach ($arrOfStartEnds AS $arrOfStartEndsOne) :

			$canDo = false;
			foreach ($tempArr AS &$tempArrOne) :
				$realStart = $arrOfStartEndsOne[0];
				$realEnd = $arrOfStartEndsOne[1];

				$tempStart = $tempArrOne[0];
				$tempEnd = $tempArrOne[1];

				if ($realStart >= $tempEnd) {

					$tempArrOne[1] = $realEnd;
					$canDo = true;
					break;
				}

			endforeach;

			if ($canDo == false)
				$tempArr[] = $arrOfStartEndsOne;
		endforeach;

		return count($tempArr);
	}

	function AssignTrainersAuto($date, $startTimeOnly, $endTimeOnly, $trainersInShift, $task = "autoassign") {

		$CI = &get_instance();
		$CI -> db -> select("usersession.*");
		$CI -> db -> from('usersession');
		$CI -> db -> order_by('usersession.start_time', 'ASC');
		$CI -> db -> where(array('date(usersession.start_time)' => $date, 'TIME(usersession.start_time)  >=' => $startTimeOnly, 'TIME(usersession.end_time)  <=' => $endTimeOnly));
		$query = $CI -> db -> get();
		$resArr = $query -> result_array();
		$requiredCounter = 0;

		$tempArray = array();

		if ($resArr) :
			foreach ($resArr AS $SessionOne) :
				$sessionRealStart = AddMinuteRetunFullDate($SessionOne['start_time'], getWarmupVariable());
				$sessionRealStart = GetHourMinuteSecondOfDateTime($sessionRealStart);
				$sessionRealEnd = GetHourMinuteSecondOfDateTime($SessionOne['end_time']);
				$tempArray[] = array($sessionRealStart, $sessionRealEnd, $SessionOne['user_sessionid']);
			endforeach;

			$startDateTimeFull = date("Y-m-d H:i:s", strtotime("{$date} {$startTimeOnly}"));
			$endDateTimeFull = date("Y-m-d H:i:s", strtotime("{$date} {$endTimeOnly}"));
			$getWarmUpsSessions = AddWarmupSessions($startDateTimeFull, $endDateTimeFull);

			//-------------Check Extra Trainers For------Warm Up
			$minimamRtrainer = GetMinimumRequiredTrainersForDate($date, $startTimeOnly, $endTimeOnly);
			$ExtraTrainers = count($trainersInShift) - $minimamRtrainer;

			if ($ExtraTrainers >= 1) {/// warmUp  ones

				$allSessions = array_merge($tempArray, $getWarmUpsSessions);

			} else {
				$allSessions = $tempArray;

			}

			//------------------
			/*	echo "<pre>";
			 print_r($allSessions);
			 echo "</pre>";*/

			/*echo "<pre>";
			 print_r($trainersInShift);
			 print_r($tempArray);
			 print_r($allSessions);
			 echo "<pre>";
			 die ;*/

			if (count($tempArray) > 0) {

				if ($task == "autoassign") {
					AssignAutomtically($allSessions, $trainersInShift, "autoassign");

				}

				if ($task == "getWarmup") {
					return AssignAutomtically($allSessions, $trainersInShift, "getWarmup");

				}

			}

		endif;

		//return $requiredCounter;

	}

	function AddWarmupSessions($date_Start_Time_Hour_Minutes, $date_End_Time_Hour_Minutes) {
		$tempArrayWarm = array();
		//$tempArrayWarm[] = array($startTime, $endTimeSession, $SessionOne['user_sessionid']);*/
		$startTime = strtotime("{$date_Start_Time_Hour_Minutes}");
		$endTime = strtotime("{$date_End_Time_Hour_Minutes}");

		$newTime_TT = strtotime('-1 hours', $endTime);
		//echo date('Y-m-d H:i:s', $startTime) . "/";
		//echo date('Y-m-d H:i:s', $endTime) . "/";
		// Loop between timestamps, 1 day at a time
		$i = 0;
		$y = 1;
		do {
			$newTime = strtotime('+' . $i++ . ' hours', $startTime);
			$newHourx = date('H:i:s', $newTime);

			$newTime_end = strtotime('+' . $y++ . ' hours', $startTime);
			$newHourx_end = date('H:i:s', $newTime_end);

			$tempArrayWarm[] = array($newHourx, $newHourx_end, 0);
		} while ($newTime < $newTime_TT);

		return $tempArrayWarm;
	}

	function GetMinimumRequiredTrainersForDate($date, $startTimeOnly, $endTimeOnly) {

		$CI = &get_instance();
		$CI -> db -> select("usersession.*");

		/*$date_Start_Time = date_create($startDateTime);
		 $date_Start_Time_Hour_Minutes = strtolower(date_format($date_Start_Time, 'H:i:s'));
		 $date = GetDateOnlyFromDateTime($startDateTime);

		 $date_End_Time = date_create($endateTime);
		 $date_End_Time_Hour_Minutes = strtolower(date_format($date_End_Time, 'H:i:s'));*/

		$CI -> db -> from('usersession');
		//$CI -> db -> join('sessions', 'usersession.sesssion_id = sessions.session_id');

		//$CI -> db -> where(array('date(sessions.start_time)' => $date));
		$CI -> db -> order_by('usersession.start_time', 'ASC');

		$CI -> db -> where(array('date(usersession.start_time)' => $date, 'TIME(usersession.start_time)  >=' => $startTimeOnly, 'TIME(usersession.end_time)  <=' => $endTimeOnly));

		$query = $CI -> db -> get();
		$resArr = $query -> result_array();
		$requiredCounter = 0;

		$tempArray = array();

		if ($resArr) :
			foreach ($resArr AS $SessionOne) :
				$ClientStartTime = $SessionOne['start_time'];
				$sessionRealStart = AddMinuteRetunFullDate($ClientStartTime, getWarmupVariable());

				$tempArray[] = array($sessionRealStart, $SessionOne['end_time'], 1, $SessionOne['user_id']);
			endforeach;

			if (count($tempArray) > 0)
				$requiredCounter = genereateRequiredArray($tempArray);

		endif;

		/*echo "<pre>";
		 print_r($tempArray);
		 echo "</pre>";*/

		return $requiredCounter;

	}

	// this function takes in mind the warmup time
	function checkCanRegisterSessionAtTimeInterval($intDateTime, $intervalTime, $capacity, $newSessionDuration) {
		$startIntervaldateTime = $intDateTime;
		$clientStartSession = $intDateTime;
		///
		// $intDateTime is Client  Start time (warmup+real traing Time)
		//--those lines updated
		/*$warpUptime = getWarmupVariable();
		 $old_date_W = date($startIntervaldateTime);
		 $date_new_W = date_create($old_date_W);
		 date_add($date_new_W, date_interval_create_from_date_string("$warpUptime minutes"));
		 $startIntervaldateTime = date_format($date_new_W, 'Y-m-d H:i:s');*/

		//-------the update 25_2_2015//
		$startIntervaldateTime = $intDateTime;

		//--------------------------------//

		/// calculate Ent Time Session
		$old_date = date($clientStartSession);
		$date_new = date_create($old_date);
		date_add($date_new, date_interval_create_from_date_string("$newSessionDuration minutes"));
		$endIntervaldateTime = date_format($date_new, 'Y-m-d H:i:s');

		$mint = 0;
		$canDo = 1;
		$increaseDateTime = $startIntervaldateTime;

		/*while ($increaseDateTime <= $endIntervaldateTime) {

		 $old_date_X = date($startIntervaldateTime);
		 $date_new_X = date_create($old_date_X);
		 date_add($date_new_X, date_interval_create_from_date_string("$mint minutes"));
		 $date_new_interal = date_format($date_new_X, 'Y-m-d H:i:s');
		 $capacityOfNextInterval = getExitsCapacityAtTimeInterval($date_new_interal);
		 $increaseDateTime = $date_new_interal;
		 if ($capacityOfNextInterval >= $capacity) {
		 $canDo = 0;
		 break;
		 }
		 $mint++;
		 }*/
		//-----The Updated Lines 25_2_2015//
		$capacityOfNextInterval = getExitsCapacityAtTimeInterval($increaseDateTime);
		if ($capacityOfNextInterval >= $capacity) {
			$canDo = 0;

		}
		//----------------------//

		return $canDo;

	}

	function getExitsCapacityAtTimeInterval($dateTime) {
		$CI = &get_instance();
		$CI -> db -> select("count(*) As Total");

		//$where = "((start_time < '{$dateTime}' AND end_time > '{$dateTime}') OR (start_time = '{$dateTime}'))";
		///updated 25_2_2015
		$where = "(start_time = '{$dateTime}' AND is_permanent = 1)";

		$CI -> db -> where($where);
		$CI -> db -> order_by('start_time', 'ASC');
		$query = $CI -> db -> get('usersession');
		$resArr = $query -> result();

		return $resArr[0] -> Total;
		/*if ($resArr)
		 return count($resArr);
		 else
		 return 0;*/

	}

	function getAvailableSlotsFromToDateTime($startDateTime, $endDateTime, $capacity, $intervalTime, $newSessionDuration) {

		$arrOfintervals = array();

		$arrOfBookedintervals = array();

		$mint = 0;
		$date_intervals_start = $startDateTime;

		//$date = date_create('2000-01-20');
		// to prevent book at end of shifts
		$endDateTime = date("Y-m-d H:i:s", strtotime("-{$newSessionDuration} minutes", strtotime($endDateTime)));

		//echo $endDateTime;
		while ($date_intervals_start <= $endDateTime) {

			$old_date = date($startDateTime);
			$date_new = date_create($old_date);
			date_add($date_new, date_interval_create_from_date_string("$mint minutes"));
			$date_intervals = date_format($date_new, 'Y-m-d H:i:s');
			$date_intervals_start = $date_intervals;
			if ($date_intervals <= $endDateTime) {
				$arrOfintervals[] = $date_intervals;

				//$bookedIninterval = getExitsCapacityAtTimeInterval($date_intervals);
				//if ($bookedIninterval < $capacity) {

				// check for next ones
				$canAddOne = checkCanRegisterSessionAtTimeInterval($date_intervals, $intervalTime, $capacity, $newSessionDuration);
				if ($canAddOne == 1) {
					//-$arrOfBookedintervals[$date_intervals] = array("currentCapacity" => $bookedIninterval, "canRegister" => $canAddOne);
					$arrOfBookedintervals[] = $date_intervals;
				}

				//}

			}

			$mint += $intervalTime;

		}

		/*for ($mint = 0; $mint <= 60 * 24; $mint += $intervalTime) :
		 $old_date = date($startDateTime);
		 $date_new = date_create($old_date);
		 date_add($date_new, date_interval_create_from_date_string("$mint minutes"));
		 $date_intervals = date_format($date_new, 'Y-m-d H:i:s');
		 if ($date_intervals <= $endDateTime) {
		 $arrOfintervals[] = $date_intervals;
		 } else {
		 break;
		 }
		 endfor;*/

		/*if (count($arrOfintervals) > 0) :
		 foreach ($arrOfintervals As $intKey => $intDateTime) :
		 $bookedIninterval = getExitsCapacityAtTimeInterval($intDateTime);
		 $canAddOne = checkCanRegisterSessionAtTimeInterval($intDateTime, $intervalTime, $capacity, $newSessionDuration);
		 //if($bookedIninterval && count($bookedIninterval)< $capacity){
		 $arrOfBookedintervals[$intDateTime] = array("currentCapacity" => $bookedIninterval, "canRegister" => $canAddOne);
		 //}

		 endforeach;

		 endif;*/

		return $arrOfBookedintervals;

	}

	function checkCanFutureDayBook($dateTimeslot, $sessionDuration) {

		$nextSlotDayCan = 1;
		$date = GetDateOnlyFromDateTime($dateTimeslot);
		$shiftOfSlot = GetShiftDataByDateTime($dateTimeslot);

		if (empty($shiftOfSlot) || count($shiftOfSlot) < 1) {/// not shift created in this time
			$nextSlotDayCan = 0;
			return $nextSlotDayCan;
		}

		$shiftData = $shiftOfSlot;
		$intervalTime = $shiftData['intervalTime'];
		$capacity = $shiftData['capacity'];

		$canAddOne = checkCanRegisterSessionAtTimeInterval($dateTimeslot, $intervalTime, $capacity, $newSessionDuration);
		if ($canAddOne == 1) {
			$nextSlotDayCan = 1;

		} else {
			$nextSlotDayCan = 0;
		}

		return $nextSlotDayCan;

	}

	function getAvailableSlotsByDateAndDuration($date, $sessionDuration) {
		$shiftsInDay = GetDaysShifts($date);

		$arrshiftsInday = array();
		$arrAvailableSlots = array();

		if ($shiftsInDay) :
			foreach ($shiftsInDay AS $shiftOne) :

				$startTime = GetHourMinuteOfDateOnly($shiftOne['start_time']);
				$startDateTime = date("Y-m-d H:i:s", strtotime("{$date} {$startTime}:00"));
				$endTime = GetHourMinuteOfDateOnly($shiftOne['end_time']);
				$endDateTime = date("Y-m-d H:i:s", strtotime("{$date} {$endTime}:00"));

				$arrshiftsInday[] = array("date" => $date, "startDateTime" => $startDateTime, "endDateTime" => $endDateTime, "capacity" => $shiftOne['capacity'], "intervalTime" => $shiftOne['intervalTime']);

				$vailableSlostInShift = getAvailableSlotsFromToDateTime($startDateTime, $endDateTime, $shiftOne['capacity'], $shiftOne['intervalTime'], $sessionDuration);
				//if ($vailableSlostInShift) {
				//$arrAvailableSlots[$shiftOne['shift_name']] = $vailableSlostInShift;
				$arrAvailableSlots = array_merge($arrAvailableSlots, $vailableSlostInShift);
				//}
				//$arrAvailableSlots[]=

			endforeach;
		endif;

		return $arrAvailableSlots;

	}

	function getVailableSessionsIndayFromTo($start_Date, $end_Date, $sessionDuration) {
		//- $sessionDuration 30/60
		$arrOfDaysInperiod = array();
		$existsInAlldays = array();
		$Dweeks = 0;
		$start_DateTemporary = $start_Date;

		while ($start_DateTemporary <= $end_Date) {

			$old_date_weeks = date($start_Date);
			$date_new_weeks = date_create($old_date_weeks);
			date_add($date_new_weeks, date_interval_create_from_date_string("$Dweeks Weeks"));
			$date_weeks = date_format($date_new_weeks, 'Y-m-d');
			$start_DateTemporary = $date_weeks;
			if ($start_DateTemporary <= $end_Date) {
				$arrOfDaysInperiod[] = $date_weeks;
			}

			$Dweeks++;

		}

		$numberOfDaysFromStartToEnd = count($arrOfDaysInperiod);
		$availableSlotsInFIrstDay = getAvailableSlotsByDateAndDuration($start_Date, $sessionDuration);
		unset($arrOfDaysInperiod[0]);

		$totalExceptFirst = $numberOfDaysFromStartToEnd - 1;
		/// number of repeated days -1

		if ($numberOfDaysFromStartToEnd > 1) :

			if ($availableSlotsInFIrstDay) :
				/*
				 [0] => 2015-02-03 02:10:00
				 */

				foreach ($availableSlotsInFIrstDay AS $firstKey => $firstDateTime) :
					$temporaryCounter = 0;

					$firstDayTimeonly = GetHourMinuteOfDateOnly($firstDateTime);

					if ($arrOfDaysInperiod) :
						foreach ($arrOfDaysInperiod AS $dayOneKey => $dayOneDate) :

							$nextDate = $dayOneDate;
							///date Only

							$NextstartDateTime = date("Y-m-d H:i:s", strtotime("{$nextDate} {$firstDayTimeonly}:00"));

							$nextDayCanBook = checkCanFutureDayBook($NextstartDateTime, $sessionDuration);
							$temporaryCounter = $temporaryCounter + $nextDayCanBook;
							//-$tempxxx[] = array($NextstartDateTime, $nextDayCanBook);
						endforeach;
					endif;

					if ($temporaryCounter >= $totalExceptFirst) {
						$existsInAlldays[] = "{$firstDayTimeonly}:00";
					}

				endforeach;
			endif;

		endif;
		return $existsInAlldays;

	}

	function getVailableSessionsInday($date) {

		$CI = &get_instance();
		$CI -> db -> select("*");

		$date_Start = date_create($date);
		$date_Start_DAY = strtolower(date_format($date_Start, 'l'));

		//$CI -> db -> where(array('DAYNAME(start_time)' => $date_Start_DAY));
		$CI -> db -> where(array('DAYNAME(start_time)' => $date_Start_DAY, "available >" => 0));
		//---Here Must Be Checked As Permanat In All Days
		$CI -> db -> order_by('start_time', 'ASC');
		$query = $CI -> db -> get('sessions');
		$resArr = $query -> result_array();

		return $resArr;

	}

	function CheckaVailableSessionsInSpecificday($startDateTime) {

		$CI = &get_instance();
		$CI -> db -> select("*");

		//$CI -> db -> where(array('DAYNAME(start_time)' => $date_Start_DAY));
		$CI -> db -> where(array('start_time' => $startDateTime, "available >" => 0));
		//---Here Must Be Checked As Permanat In All Days
		$CI -> db -> order_by('start_time', 'ASC');
		$query = $CI -> db -> get('sessions');
		$resArr = $query -> result_array();

		if ($resArr) {
			return $resArr[0];
		}
		return false;

	}

	function getVailableSessionsInSpecificday($date) {

		$CI = &get_instance();
		$CI -> db -> select("*");

		//$CI -> db -> where(array('DAYNAME(start_time)' => $date_Start_DAY));
		$CI -> db -> where(array('date(start_time)' => $date, "available >" => 0));
		//---Here Must Be Checked As Permanat In All Days
		$CI -> db -> order_by('start_time', 'ASC');
		$query = $CI -> db -> get('sessions');
		$resArr = $query -> result_array();

		return $resArr;

	}

	function GetCoachUserSessionsInDay($coachId, $date) {

		$CI = &get_instance();
		$CI -> db -> select("*");
		$CI -> db -> where(array('date(start_time)' => $date, 'coach_id' => $coachId));
		$query = $CI -> db -> get('usersession');
		$resArr = $query -> result_array();
		return $resArr;

	}

	function UnassignUserSessionsFromCoachByShift($shift_id, $coachid, $date) {
		$CI = &get_instance();
		$CI -> load -> model('main_model');

		$shiftData = getTableData("shifts", array("shift_id" => $shift_id));
		/*var_dump($coachid);
		 var_dump($date);
		 var_dump($shiftData);
		 die;*/
		if ($shiftData) {
			$shiftData = $shiftData[0];

			$startTimeOnly = GetHourMinuteSecondOfDateTime($shiftData -> start_time);
			$endTimeOnly = GetHourMinuteSecondOfDateTime($shiftData -> end_time);
			/*$CI -> db -> select("usersession.*");
			 $CI -> db -> from('usersession');
			 $CI -> db -> order_by('usersession.start_time', 'ASC');
			 $CI -> db -> where(array('date(usersession.start_time)' => $date, 'TIME(usersession.start_time)  >=' => $startTimeOnly, 'TIME(usersession.end_time)  <=' => $endTimeOnly));
			 $query = $CI -> db -> get();
			 $resArr = $query -> result_array();*/

			$CI -> main_model -> update('usersession', array("coach_id" => 0), array('date(usersession.start_time)' => $date, 'TIME(usersession.start_time)  >=' => $startTimeOnly, 'TIME(usersession.end_time)  <=' => $endTimeOnly, "coach_id" => $coachid));

		}
	}

	function CheckIfCoachChecedInShift($userId, $dateTime, $shiFtId) {

		$CI = &get_instance();
		$CI -> db -> select("*");
		$CI -> db -> where(array('date(datetimecheckin)' => GetDateOnlyFromDateTime($dateTime), 'shift_id' => $shiFtId, 'coach_id' => $userId));
		$query = $CI -> db -> get('coach_checkin');
		$resArr = $query -> result_array();
		if ($resArr)
			return 1;
		else
			return 0;

	}

	function CheckCoachChecedIn($userId, $date) {

		$CI = &get_instance();
		$CI -> db -> select("*");
		$CI -> db -> where(array('date(datetimecheckin)' => GetDateOnlyFromDateTime($date), 'coach_id' => $userId));
		$query = $CI -> db -> get('coach_checkin');
		$resArr = $query -> result_array();
		if ($resArr)
			return 1;
		else
			return 0;

	}

	function GetDateOnlyFromDateTime($dateTime) {

		$date_new = date_create($dateTime);
		return date_format($date_new, 'Y-m-d');

	}

	function CheckifCustomshiftsExist($date) {

		$CI = &get_instance();
		$CI -> db -> select("*");
		$CI -> db -> where(array('date(start_time)' => GetDateOnlyFromDateTime($date), 'shiftType' => 2));
		$CI -> db -> order_by('start_time', 'ASC');
		$query = $CI -> db -> get('shifts');
		$resArr = $query -> result_array();
		if ($resArr)
			return 2;
		else
			return 1;

	}

	function GetPermanentShiftsByDate($startDate) {
		$CI = &get_instance();
		$CI -> db -> select("*");
		$CI -> db -> where(array('date(start_time)' => GetDateOnlyFromDateTime($startDate), 'shiftType' => 1));
		$CI -> db -> order_by('start_time', 'ASC');
		$query = $CI -> db -> get('shifts');
		$resArr = $query -> result_array();

		return $resArr;

	}

	function GetShiftNameByDate($startDateTime, $endDateTime) {
		///- get Day

		$shiftType = CheckifCustomshiftsExist($startDateTime);

		/*
		 if ($shiftType == 2)
		 $CI -> db -> where(array('date(start_time)' => $date, 'shiftType' => 2));
		 else
		 $CI -> db -> where(array("DAYNAME(start_time)" => $date_new, 'shiftType' => 1));
		 **/

		$CI = &get_instance();
		$CI -> db -> select("*");

		if ($shiftType == 2) :// custom
			$CI -> db -> where(array('date(start_time)' => GetDateOnlyFromDateTime($startDateTime), 'start_time  <=' => $startDateTime, 'date(end_time)' => GetDateOnlyFromDateTime($endDateTime), 'end_time  >=' => $endDateTime, 'shiftType' => 2));
		else :

			//$date="2015-01-23 20:00:00";
			$date_Start_Time = date_create($startDateTime);
			$date_Start_Time_DAY = strtolower(date_format($date_Start_Time, 'l'));
			$date_Start_Time_Hour_Minutes = strtolower(date_format($date_Start_Time, 'H:i:s'));

			$date_End_Time = date_create($endDateTime);
			$date_End_Time_DAY = strtolower(date_format($date_End_Time, 'l'));
			$date_End_Time_Hour_Minutes = strtolower(date_format($date_End_Time, 'H:i:s'));

			$CI -> db -> where(array('DAYNAME(start_time)' => $date_Start_Time_DAY, 'TIME(start_time)  <=' => $date_Start_Time_Hour_Minutes, 'DAYNAME(end_time)' => $date_End_Time_DAY, 'TIME(end_time)  >=' => $date_End_Time_Hour_Minutes, 'shiftType' => 1));

		endif;

		$CI -> db -> order_by('start_time', 'ASC');
		$query = $CI -> db -> get('shifts');
		$resArr = $query -> result_array();

		if ($resArr)
			return $resArr[0]['shift_name'];
		else
			return " ";

	}

	function GetHourMinuteOfDate($datePassed) {

		$date = date_create($datePassed);
		return date_format($date, 'h:i A');

	}

	function GetHourMinuteSecondOfDateTime($datePassed) {

		$date = date_create($datePassed);
		return date_format($date, 'H:i:s');

	}

	function GetHourMinuteOfDateOnly($datePassed) {

		$date = date_create($datePassed);
		return date_format($date, 'H:i');

	}

	function AddMinuteRetunFullDate($date_Time, $NumberOfminutes) {

		$date_new = date_create($date_Time);
		date_add($date_new, date_interval_create_from_date_string("$NumberOfminutes minutes"));

		return date_format($date_new, 'Y-m-d H:i:s');

	}

	function GetAddMinutesTodate($datePassed, $NumberOfminutes) {

		$date_new = date_create($datePassed);
		date_add($date_new, date_interval_create_from_date_string("$NumberOfminutes minutes"));
		return date_format($date_new, 'h:i A');

	}

	function GetRemainingSessions($userId) {

		$activePackage = getCurrentPackage($userId);

		$remainingSessions = 0;
		if ($activePackage) :

			$remainingSessions = $activePackage -> remainingsessions;

		endif;
		return $remainingSessions;
	}

	function GetUserSessionsByDayAndUserId($userId, $date) {

		$CI = &get_instance();
		$CI -> db -> select("*");

		$CI -> db -> from('usersession');
		//$CI -> db -> join('sessions', 'usersession.sesssion_id = sessions.session_id');

		$CI -> db -> where(array('date(usersession.start_time)' => $date, 'user_id' => $userId));
		$CI -> db -> order_by('usersession.start_time', 'ASC');
		$query = $CI -> db -> get();
		//$query = $CI -> db -> get('sessions');
		$resArr = $query -> result_array();
		if ($resArr && count($resArr) > 0) {
			return $resArr[0];
		}

		return false;

	}

	function GetUsersSessionsByDay($date) {

		$CI = &get_instance();
		$CI -> db -> select("*");

		$CI -> db -> from('usersession');
		//$CI -> db -> join('sessions', 'usersession.sesssion_id = sessions.session_id');

		$CI -> db -> where(array('date(usersession.start_time)' => $date));
		$CI -> db -> order_by('usersession.start_time', 'ASC');
		$query = $CI -> db -> get();
		//$query = $CI -> db -> get('sessions');
		$resArr = $query -> result_array();

		return $resArr;

	}

	function GetSessionsShifts($date) {

		$CI = &get_instance();
		$CI -> db -> select("*");
		$CI -> db -> where(array('date(start_time)' => $date));
		$CI -> db -> order_by('start_time', 'ASC');
		$query = $CI -> db -> get('usersession');
		$resArr = $query -> result_array();

		return $resArr;

	}

	function GetDaysShifts($date) {

		$shiftType = CheckifCustomshiftsExist($date);

		$CI = &get_instance();
		$CI -> db -> select("*");

		//$date="2015-01-23 20:00:00";
		$date_new = date_create($date);
		//echo $date."<br/>";
		$date_new = strtolower(date_format($date_new, 'l'));

		if ($shiftType == 2)
			$CI -> db -> where(array('date(start_time)' => $date, 'shiftType' => 2));
		else
			$CI -> db -> where(array("DAYNAME(start_time)" => $date_new, 'shiftType' => 1));

		$CI -> db -> order_by('start_time', 'ASC');
		$query = $CI -> db -> get('shifts');
		$resArr = $query -> result_array();

		return $resArr;

	}

	function GetArabicMonths($mONTH) {

		$months = array("Jan" => "يناير", "Feb" => "فبراير", "Mar" => "مارس", "Apr" => "أبريل", "May" => "مايو", "Jun" => "يونيو", "Jul" => "يوليو", "Aug" => "أغسطس", "Sep" => "سبتمبر", "Oct" => "أكتوبر", "Nov" => "نوفمبر", "Dec" => "ديسمبر");
		return $months[$mONTH];

	}

	function GetArabicDay($date_new_D) {
		$find = array("Sat", "Sun", "Mon", "Tue", "Wed", "Thu", "Fri");

		$replace = array("السبت", "الأحد", "الإثنين", "الثلاثاء", "الأربعاء", "الخميس", "الجمعة");
		$date_new_D = str_replace($find, $replace, $date_new_D);
		return $date_new_D;
	}

	function CheckCanReschedule($dateX, $hourX) {

		$sessionDate = $dateX;
		$sessionHour = $hourX;
		$date_new = date_create($sessionDate);
		date_add($date_new, date_interval_create_from_date_string("$sessionHour hours"));
		$date_new = date_format($date_new, 'Y-m-d H:i:s');
		$dateNOw = date('Y-m-d H:i:s');
		$date1 = date_create("$date_new");
		//$sessinData['date1'] = $date1;
		$date2 = date_create("$dateNOw");
		//$sessinData['date2'] = $date2;
		$diff12 = date_diff($date2, $date1);
		$Diff_Hours = $diff12 -> h;
		$Diff_Days = $diff12 -> d;
		$diFFInHours = ($Diff_Days * 24) + $Diff_Hours;
		//	return $dateNOw ." *** ".$date_new ." *** ".$diFFInHours;
		if ($diFFInHours < 24) {
			return false;
		}

		return true;

	}

	function CheckPassedSession($dateX, $hourX) {

		$sessionDate = $dateX;
		$sessionHour = $hourX;
		$date_new = date_create($sessionDate);
		date_add($date_new, date_interval_create_from_date_string("$sessionHour hours"));
		$date_new = date_format($date_new, 'Y-m-d H:i:s');
		$dateNOw = date('Y-m-d H:i:s');
		$date1 = date_create("$date_new");
		//$sessinData['date1'] = $date1;
		$date2 = date_create("$dateNOw");

		if ($date2 >= $date1) {
			return true;
		}

		return false;

	}

	function check_permission($methodName) {
		return true;
		/*
		 $methodName = strtolower($methodName);

		 if (strpos($methodName, "jax") !== false)
		 return true;
		 //if(strpos($methodName, "jax"))
		 //return true;

		 $CI = &get_instance();
		 $admin_role = $CI -> session -> userdata('admin_role');
		 if ($admin_role < 2)
		 return false;

		 $fieldName = "";

		 if ($admin_role == 2)
		 $fieldName = "coach";
		 else if ($admin_role == 3)
		 $fieldName = "accountant";
		 else if ($admin_role == 4)
		 $fieldName = "receptionist";
		 else if ($admin_role == 5)
		 $fieldName = "admin";
		 else if ($admin_role == 6)
		 $fieldName = "coach_head";

		 $CI = &get_instance();
		 $selCTStment = " SELECT $fieldName As permisssionValue From permissionMethods
		 WHERE  (method_name='$methodName')";
		 $query = $CI -> db -> query($selCTStment);
		 $resArr = $query -> result_array();
		 if ($resArr) {

		 $row = $resArr[0];
		 $permissionValue = $row['permisssionValue'];
		 if ($permissionValue > 0) {
		 return true;
		 } else {
		 return false;
		 }

		 }
		 //if()

		 return false;*/

	}

	function HourFormat($hour, $langId = 1) {

		if ($hour <= 12)
			$sign = " AM";
		else
			$sign = " PM";

		if ($hour == 12)
			$sign = " PM";

		if ($hour == 24)
			$sign = " AM";

		if ($hour != 12 && $hour != 24)
			$hour = ($hour % 12);

		if ($hour == 24)
			$hour = 12;
		if ($langId == 2) {

			$sign = ($sign == " AM") ? " ص" : " م";
		}

		$temHour = $hour . $sign;

		return $temHour;
	}

	function getEndOfSubScriptionAndGP($userId) {

		$currentPCK = getCurrentPackage($userId);

		$packageId = $currentPCK -> package_id;
		$SubScripTionEnDate = $currentPCK -> end_date;

		$packageData = getTableData("packages", array("package_id" => $packageId));
		$packageData = $packageData[0];

		$gracePeriod = $packageData -> gracePeriod;

		$date_new = date_create($SubScripTionEnDate);
		date_add($date_new, date_interval_create_from_date_string("$gracePeriod weeks"));
		$endSubAndGP = date_format($date_new, 'Y-m-d');
		return $endSubAndGP;
	}

	function getCurrentPackage($userID) {

		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$row = $CI -> main_model -> getData("subscriptions", '*', array("user_id" => $userID), "end_date", "DESC");
		if ($row)
			$row = $row[0];
		return $row;
	}

	function getSesssionData($sessionID) {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		//if(count($where) >0)
		$row = $CI -> main_model -> getData("sessions", '*', array("session_id" => $sessionID));
		if ($row)
			$row = $row[0];
		return $row;
	}

	function checkClosedSession($date, $hour) {
		$CI = &get_instance();

		$selCTStment = " SELECT * From sessions 
		WHERE  (sessions.date='$date' AND  sessions.hour='$hour' AND status=2)";
		$query = $CI -> db -> query($selCTStment);
		$resArr = $query -> result_array();
		if ($resArr) :
			return true;
		endif;

		return false;

	}

	function getHourStatusForTrainer($date, $hour, $trainerId = 0) {
		$CI = &get_instance();

		$selCTStment = " SELECT hour ,  status From sessions 
		WHERE  (
		(sessions.date='$date' AND  sessions.hour='$hour' AND  sessions.coach_id='$trainerId' )
		 OR (sessions.date='$date' AND  sessions.hour='$hour' AND status=2  ))
		
		";

		$query = $CI -> db -> query($selCTStment);
		$resArr = $query -> result_array();

		$hourClss = "EmptyHour";
		if ($resArr) :
			$oneArray = $resArr[0];
			$status = $oneArray['status'];

			if ($status == 1)
				$hourClss = "ReservedHour";

			if ($status == 2)
				$hourClss = "ClosedHour";

		endif;

		return $hourClss;

	}

	function getDayStatusForTrainer($date, $trainerId = 0) {

		$CI = &get_instance();
		$CI -> db -> select("usersession.*");
		$CI -> db -> from('usersession');
		$CI -> db -> order_by('usersession.start_time', 'ASC');
		$CI -> db -> where(array('date(usersession.start_time)' => $date, 'usersession.coach_id' => $trainerId));
		$query = $CI -> db -> get();
		$resArr = $query -> result_array();
		return $resArr;

	}

	function getDateForClient($date, $clientId = 0) {
		/*$CI = &get_instance();
		 $selCTStment = " SELECT * From sessions
		 WHERE
		 (sessions.date='$date'  AND  sessions.user_id='$clientId' )
		 ";
		 $query = $CI -> db -> query($selCTStment);
		 $resArr = $query -> result_array();
		 return $resArr;*/

		$CI = &get_instance();
		$CI -> db -> select("usersession.*");
		$CI -> db -> from('usersession');
		$CI -> db -> order_by('usersession.start_time', 'ASC');
		$CI -> db -> where(array('date(usersession.start_time)' => $date, 'usersession.user_id' => $clientId));
		$query = $CI -> db -> get();
		$resArr = $query -> result_array();
		return $resArr;

	}

	function getFirstAvailableSessionIdForClient($clientId = 0) {
		$CI = &get_instance();
		$selCTStment = " SELECT * From sessions 
		WHERE  
		(  sessions.user_id='$clientId' AND date > CURDATE() + INTERVAL 1 DAY)
		";
		$query = $CI -> db -> query($selCTStment);
		$resArr = $query -> result_array();
		return $resArr;

	}

	function getHourStatusForClienT($date, $hour, $clientId = 0) {

		$CI = &get_instance();

		$selCTStment = " SELECT hour ,  status From sessions 
WHERE  (
(sessions.date='$date' AND  sessions.hour='$hour' AND  sessions.user_id='$clientId' )
 OR (sessions.date='$date' AND  sessions.hour='$hour' AND status=2  ))

";

		$query = $CI -> db -> query($selCTStment);
		$resArr = $query -> result_array();

		$hourClss = "EmptyHour";
		if ($resArr) :
			$oneArray = $resArr[0];
			$status = $oneArray['status'];

			if ($status == 1)
				$hourClss = "ReservedHour";

			if ($status == 2)
				$hourClss = "ClosedHour";

		endif;

		return $hourClss;

	}

	function getHourStatus($date, $hour) {

		$CI = &get_instance();

		$CI -> db -> select("hour, max(status) AS status");

		$CI -> db -> where(array('date' => $date, 'hour' => $hour));
		//$CI->db->group_by("sessions.hour");
		$CI -> db -> order_by('hour', 'ASC');
		$query = $CI -> db -> get('sessions');
		$resArr = $query -> result_array();

		$hourClss = "EmptyHour";
		if ($resArr) :
			$oneArray = $resArr[0];
			$status = $oneArray['status'];

			if ($status == 1)
				$hourClss = "ReservedHour";

			if ($status == 2)
				$hourClss = "ClosedHour";

		endif;

		return $hourClss;

	}

	function save_message_toDB($MessageArr) {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		$MessageArr['date'] = date("Y-m-d H:i:s");
		$CI -> main_model -> insert('messages', $MessageArr);
	}

	function save_Some_Send_message($MessageArr, $userArr) {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		if (is_array($userArr) && count($userArr) > 0) :
			$userValue = implode(",", $userArr);
			$MessageArr['user_id'] = $userValue;
			//$MessageArr['message_type_id'] = 3;
			save_message_toDB($MessageArr);
		endif;
	}

	function save_All_pushed_message($MessageArr) {
		$CI = &get_instance();
		$CI -> load -> model('main_model');
		$MessageArr['user_id'] = "*";
		//$MessageArr['message_type_id'] = 2;
		save_message_toDB($MessageArr);
	}

	function hideFrame() {

	}

}
?>