<?php
if (!defined('BASEPATH'))
	exit('No direct script access allowed');

class Notification_lib {


	function push_android_schedule($deviceRegistrationId, $messageArr ,$type="notification")
	{
		// $apiKey= 'AIzaSyDFSUsDaFqofFaPTQOZmRht3IMwJUcHjrc';  AIzaSyAtfVLoYoAZpmU1MSb_BaUoen9OExvw-vg
		 $apiKey= 'AIzaSyC9OGKm3vnkT2YIn2UzC1ZaE6VUn2_LW_8';  
		$headers = array("Content-Type:" . "application/json", "Authorization:" . "key=" . $apiKey);
		$data = array(
		'data' => array(
		'message' => $messageArr['message'],
		'session_id' => $messageArr['session_id'],
		'section_id' => $messageArr['section_id'],
		'type'=>$type),
		'registration_ids' => array($deviceRegistrationId),

		);
		 
		$ch = curl_init();
		 
		curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers );
		curl_setopt( $ch, CURLOPT_URL, "https://android.googleapis.com/gcm/send" );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, 0 );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, 0 );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_POSTFIELDS, json_encode($data) );
		 
		$response = curl_exec($ch);
		curl_close($ch);
		 
		echo $response;
	}
		public function push_iphone_schedule($deviceToken, $messageArr,$type='notification' ) {
	
		
		//$passphrase = "manal";
		$passphrase = "123456789"; ///-test
		//---$passphrase = "tawasolit";   /// live
		$ctx = stream_context_create();
		stream_context_set_option($ctx, 'ssl', 'local_cert', FCPATH . 'third_party/ck.pem');
		stream_context_set_option($ctx, 'ssl', 'passphrase', $passphrase);

		// Open a connection to the APNS server
		$fp = stream_socket_client('ssl://gateway.sandbox.push.apple.com:2195', $err, $errstr, 60, STREAM_CLIENT_CONNECT | STREAM_CLIENT_PERSISTENT, $ctx);
		//-$fp = stream_socket_client('ssl://gateway.push.apple.com:2195', $err, $errstr, 60, STREAM_CLIENT_CONNECT | STREAM_CLIENT_PERSISTENT, $ctx);

		if (!$fp)
			exit("Failed to connect: $err $errstr" . PHP_EOL);

		//echo 'Connected to APNS' . PHP_EOL;

		// Create the payload body
		//$body['aps'] = array('alert' => array('body' => $message, 'action-loc-key' => 'Bango App', ), 'badge' => 2, 'sound' => 'oven.caf', );

		
		$body['aps']['alert'] = array('action-loc-key' => 'view',
		'body' => $messageArr['message'],
		'message' => $messageArr['message'],
		'session_id' => $messageArr['session_id'],
		'section_id' => $messageArr['section_id']
		
		
		);
		$body['aps']['sound'] = 'default';
		$body['badge'] = '1';
		$body['type'] = $type;

		// Encode the payload as JSON
		$payload = json_encode($body);

		//print_r($payload);
		// Build the binary notification
		$msg = chr(0) . pack('n', 32) . pack('H*', $deviceToken) . pack('n', strlen($payload)) . $payload;

		// Send it to the server
		$result = fwrite($fp, $msg, strlen($msg));
/*
		if (!$result)
			//echo 'Message not delivered' . PHP_EOL;
		else
			echo 'Message successfully delivered' . PHP_EOL.'<br>';
*/
		// Close the connection to the server
		fclose($fp);
	}
	
	function push_android($deviceRegistrationId, $messageText ,$type="notification")
	{
		// $apiKey= 'AIzaSyDFSUsDaFqofFaPTQOZmRht3IMwJUcHjrc';  AIzaSyAtfVLoYoAZpmU1MSb_BaUoen9OExvw-vg
		 $apiKey= 'AIzaSyC9OGKm3vnkT2YIn2UzC1ZaE6VUn2_LW_8';  
		$headers = array("Content-Type:" . "application/json", "Authorization:" . "key=" . $apiKey);
		$data = array(
		'data' => array('message' => $messageText,'type'=>$type),
		'registration_ids' => array($deviceRegistrationId),

		);
		 
		$ch = curl_init();
		 
		curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers );
		curl_setopt( $ch, CURLOPT_URL, "https://android.googleapis.com/gcm/send" );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, 0 );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, 0 );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_POSTFIELDS, json_encode($data) );
		 
		$response = curl_exec($ch);
		curl_close($ch);
		 
		echo $response;
	}

	public function push_iphone($deviceToken, $message,$type='notification' ) {
	
		
		//$passphrase = "manal";
		$passphrase = "tawasolit"; ///-test
		//---$passphrase = "tawasolit";   /// live
		$ctx = stream_context_create();
		stream_context_set_option($ctx, 'ssl', 'local_cert', FCPATH . 'third_party/ck.pem');
		stream_context_set_option($ctx, 'ssl', 'passphrase', $passphrase);

		// Open a connection to the APNS server
		$fp = stream_socket_client('ssl://gateway.sandbox.push.apple.com:2195', $err, $errstr, 60, STREAM_CLIENT_CONNECT | STREAM_CLIENT_PERSISTENT, $ctx);
		//-$fp = stream_socket_client('ssl://gateway.push.apple.com:2195', $err, $errstr, 60, STREAM_CLIENT_CONNECT | STREAM_CLIENT_PERSISTENT, $ctx);

		if (!$fp)
			exit("Failed to connect: $err $errstr" . PHP_EOL);

		//echo 'Connected to APNS' . PHP_EOL;

		// Create the payload body
		//$body['aps'] = array('alert' => array('body' => $message, 'action-loc-key' => 'Bango App', ), 'badge' => 2, 'sound' => 'oven.caf', );

		$body['aps']['alert'] = array('action-loc-key' => 'view', 'body' => $message);
		$body['aps']['sound'] = 'default';
		$body['badge'] = '1';
		$body['type'] = $type;

		// Encode the payload as JSON
		$payload = json_encode($body);

		//print_r($payload);
		// Build the binary notification
		$msg = chr(0) . pack('n', 32) . pack('H*', $deviceToken) . pack('n', strlen($payload)) . $payload;

		// Send it to the server
		$result = fwrite($fp, $msg, strlen($msg));
/*
		if (!$result)
			//echo 'Message not delivered' . PHP_EOL;
		else
			echo 'Message successfully delivered' . PHP_EOL.'<br>';
*/
		// Close the connection to the server
		fclose($fp);
	}
	
}
?>